## hypre 2.16.0

=== src/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.8)
project (hypre)

# The version number.
set (HYPRE_VERSION 2.16.0)
set (HYPRE_DATE    2019/03/20)
set (HYPRE_TIME    00:00:00)
set (HYPRE_BUGS    hypre-support@llnl.gov)
set (HYPRE_SRCDIR  "${PROJECT_SOURCE_DIR}")

if (${hypre_SOURCE_DIR} STREQUAL ${hypre_BINARY_DIR})
  message(FATAL_ERROR "In-place build not allowed! Please use a separate build directory. See the Users Manual or INSTALL file for details.")
endif ()

# Set default installation directory, but provide a means for users to change
set (HYPRE_INSTALL_PREFIX "${PROJECT_SOURCE_DIR}/hypre" CACHE PATH
  "Installation directory for HYPRE")
set (CMAKE_INSTALL_PREFIX "${HYPRE_INSTALL_PREFIX}" CACHE INTERNAL "" FORCE)

# Set default compile optimization flag
set (HYPRE_BUILD_TYPE "Release" CACHE STRING
  "Optimization flags: set to Debug, Release, RelWithDebInfo, or MinSizeRel")
set (CMAKE_BUILD_TYPE "${HYPRE_BUILD_TYPE}" CACHE INTERNAL "" FORCE)

# Configuration options
option(HYPRE_SHARED               "Build a shared library" OFF)
option(HYPRE_BIGINT               "Use long long int for HYPRE_Int" OFF)
option(HYPRE_SINGLE               "Use float for HYPRE_Real" OFF)
option(HYPRE_LONG_DOUBLE          "Use long double for HYPRE_Real" OFF)
option(HYPRE_SEQUENTIAL           "Compile without MPI" OFF)
option(HYPRE_TIMING               "Use HYPRE timing routines" OFF)
option(HYPRE_USING_HYPRE_BLAS     "Use internal BLAS library" ON)
option(HYPRE_USING_HYPRE_LAPACK   "Use internal LAPACK library" ON)
option(HYPRE_USING_PERSISTENT_COMM "Use persistent communication" OFF)
option(HYPRE_NO_GLOBAL_PARTITION  "Use assumed partition" ON)
option(HYPRE_PRINT_ERRORS         "Print HYPRE errors" OFF)
option(HYPRE_USING_OPENMP         "Use OpenMP" OFF)
option(HYPRE_HOPSCOTCH            "Use hopscotch hashing with OpenMP" OFF)
option(HAVE_DSUPERLU              "required if using SuperLU_dist" OFF)
option(HYPRE_USING_FEI            "Use FEI" ON)
option(HYPRE_USING_CALIPER        "Use Caliper" OFF)  # TODO: Finish this cmake feature

if (HYPRE_SHARED)
  # FEI doesn't currently compile with shared
  set (HYPRE_USING_FEI OFF CACHE BOOL "" FORCE)
endif ()

if (HYPRE_BIGINT)
  set (HYPRE_USING_FEI OFF CACHE BOOL "" FORCE)
endif ()

if (HYPRE_SINGLE)
  set (HYPRE_USING_FEI OFF CACHE BOOL "" FORCE)
endif ()

if (HYPRE_LONG_DOUBLE)
  set (HYPRE_USING_FEI OFF CACHE BOOL "" FORCE)
endif ()

if (HYPRE_SEQUENTIAL)
  set (HYPRE_NO_GLOBAL_PARTITION OFF CACHE BOOL "" FORCE)
endif ()

#   --with-examples         Build example codes.
#   --with-fei              Use internal FEI routines.
#   --with-superlu          Use internal SuperLU routines.
#   --with-mli              Use MLI

# Headers and sources
set (HYPRE_HEADERS "")
set (HYPRE_SOURCES "")

# Headers and sources: .
list (APPEND HYPRE_HEADERS
  "${PROJECT_BINARY_DIR}/HYPRE_config.h"
  HYPREf.h
  HYPRE.h
)

# Headers and sources: blas
list (APPEND HYPRE_SOURCES
  blas/dasum.c
  blas/daxpy.c
  blas/dcopy.c
  blas/ddot.c
  blas/dgemm.c
  blas/dgemv.c
  blas/dger.c
  blas/dnrm2.c
  blas/drot.c
  blas/dscal.c
  blas/dswap.c
  blas/dsymm.c
  blas/dsymv.c
  blas/dsyr2.c
  blas/dsyr2k.c
  blas/dsyrk.c
  blas/dtrmm.c
  blas/dtrmv.c
  blas/dtrsm.c
  blas/dtrsv.c
  blas/f2c.c
  blas/idamax.c
  blas/lsame.c
  blas/xerbla.c
)

# Headers and sources: lapack
list (APPEND HYPRE_SOURCES
  lapack/dbdsqr.c
  lapack/dgebd2.c
  lapack/dgebrd.c
  lapack/dgelq2.c
  lapack/dgelqf.c
  lapack/dgels.c
  lapack/dgeqr2.c
  lapack/dgeqrf.c
  lapack/dgesvd.c
  lapack/dgetrf.c
  lapack/dgetri.c
  lapack/dgetrs.c
  lapack/dgetf2.c
  lapack/dlabad.c
  lapack/dlabrd.c
  lapack/dlacpy.c
  lapack/dlae2.c
  lapack/dlaev2.c
  lapack/dlamch.c
  lapack/dlange.c
  lapack/dlanst.c
  lapack/dlansy.c
  lapack/dlapy2.c
  lapack/dlarfb.c
  lapack/dlarf.c
  lapack/dlarfg.c
  lapack/dlarft.c
  lapack/dlartg.c
  lapack/dlas2.c
  lapack/dlascl.c
  lapack/dlaset.c
  lapack/dlasq1.c
  lapack/dlasq2.c
  lapack/dlasq3.c
  lapack/dlasq4.c
  lapack/dlasq5.c
  lapack/dlasq6.c
  lapack/dlasr.c
  lapack/dlasrt.c
  lapack/dlassq.c
  lapack/dlaswp.c
  lapack/dlasv2.c
  lapack/dlatrd.c
  lapack/dorg2l.c
  lapack/dorg2r.c
  lapack/dorgbr.c
  lapack/dorgl2.c
  lapack/dorglq.c
  lapack/dorgql.c
  lapack/dorgqr.c
  lapack/dorgtr.c
  lapack/dorm2r.c
  lapack/dormbr.c
  lapack/dorml2.c
  lapack/dormlq.c
  lapack/dormqr.c
  lapack/dpotf2.c
  lapack/dpotrf.c
  lapack/dpotrs.c
  lapack/dsteqr.c
  lapack/dsterf.c
  lapack/dsyev.c
  lapack/dsygs2.c
  lapack/dsygst.c
  lapack/dsygv.c
  lapack/dsytd2.c
  lapack/dsytrd.c
  lapack/dtrti2.c
  lapack/dtrtri.c
  lapack/ieeeck.c
  lapack/ilaenv.c
  lapack/lsame.c
  lapack/xerbla.c
)

# Headers and sources: utilities
list (APPEND HYPRE_HEADERS
  utilities/HYPRE_utilities.h
  utilities/_hypre_utilities.h
  utilities/hypre_hopscotch_hash.h
  utilities/HYPRE_error_f.h
  utilities/fortran.h
  utilities/fortran_matrix.h
)
list (APPEND HYPRE_SOURCES
  utilities/HYPRE_version.c
  utilities/amg_linklist.c
  utilities/binsearch.c
  utilities/exchange_data.c
  utilities/F90_HYPRE_error.c
  utilities/fortran_matrix.c
  utilities/hypre_ap.c
  utilities/hypre_complex.c
  utilities/hypre_error.c
  utilities/hypre_general.c
  utilities/hypre_hopscotch_hash.c
  utilities/hypre_memory.c
  utilities/hypre_merge_sort.c
  utilities/hypre_mpi_comm_f2c.c
  utilities/hypre_prefix_sum.c
  utilities/hypre_printf.c
  utilities/hypre_qsort.c
  utilities/mpistubs.c
  utilities/qsplit.c
  utilities/random.c
  utilities/threading.c
  utilities/timer.c
  utilities/timing.c
)

# Headers and sources: multivector
list (APPEND HYPRE_HEADERS
  multivector/csr_matmultivec.h
  multivector/interpreter.h
  multivector/multivector.h
  multivector/par_csr_matmultivec.h
  multivector/par_csr_pmvcomm.h
  multivector/par_multivector.h
  multivector/seq_multivector.h
  multivector/temp_multivector.h
)
list (APPEND HYPRE_SOURCES
  multivector/multivector.c
  multivector/temp_multivector.c
)

# Headers and sources: krylov
list (APPEND HYPRE_HEADERS
  krylov/HYPRE_krylov.h
  krylov/HYPRE_lobpcg.h
  krylov/HYPRE_MatvecFunctions.h
  krylov/krylov.h
  krylov/lobpcg.h
)
list (APPEND HYPRE_SOURCES
  krylov/bicgstab.c
  krylov/cgnr.c
  krylov/cogmres.c
  krylov/gmres.c
  krylov/flexgmres.c
  krylov/lgmres.c
  krylov/HYPRE_bicgstab.c
  krylov/HYPRE_cgnr.c
  krylov/HYPRE_gmres.c
  krylov/HYPRE_cogmres.c
  krylov/HYPRE_lgmres.c
  krylov/HYPRE_flexgmres.c
  krylov/HYPRE_pcg.c
  krylov/pcg.c
  krylov/HYPRE_lobpcg.c
  krylov/lobpcg.c
)

# Headers and sources: seq_mv
list (APPEND HYPRE_HEADERS
  seq_mv/HYPRE_seq_mv.h
  seq_mv/seq_mv.h
)
list (APPEND HYPRE_SOURCES
  seq_mv/csr_matop.c
  seq_mv/csr_matrix.c
  seq_mv/csr_matvec.c
  seq_mv/genpart.c
  seq_mv/HYPRE_csr_matrix.c
  seq_mv/HYPRE_mapped_matrix.c
  seq_mv/HYPRE_multiblock_matrix.c
  seq_mv/HYPRE_vector.c
  seq_mv/mapped_matrix.c
  seq_mv/multiblock_matrix.c
  seq_mv/vector.c
)

# Headers and sources: parcsr_mv
list (APPEND HYPRE_HEADERS
  parcsr_mv/HYPRE_parcsr_mv.h
  parcsr_mv/_hypre_parcsr_mv.h
)
list (APPEND HYPRE_SOURCES
  parcsr_mv/communicationT.c
  parcsr_mv/F90_HYPRE_parcsr_matrix.c
  parcsr_mv/F90_HYPRE_parcsr_vector.c
  parcsr_mv/F90_parcsr_matrix.c
  parcsr_mv/F90_par_vector.c
  parcsr_mv/HYPRE_parcsr_matrix.c
  parcsr_mv/HYPRE_parcsr_vector.c
  parcsr_mv/new_commpkg.c
  parcsr_mv/numbers.c
  parcsr_mv/par_csr_aat.c
  parcsr_mv/par_csr_assumed_part.c
  parcsr_mv/par_csr_bool_matop.c
  parcsr_mv/par_csr_bool_matrix.c
  parcsr_mv/par_csr_communication.c
  parcsr_mv/par_csr_matop.c
  parcsr_mv/par_csr_matrix.c
  parcsr_mv/par_csr_matop_marked.c
  parcsr_mv/par_csr_matvec.c
  parcsr_mv/par_vector.c
  parcsr_mv/par_make_system.c
)

# Headers and sources: parcsr_block_mv
list (APPEND HYPRE_HEADERS
  parcsr_block_mv/par_csr_block_matrix.h
  parcsr_block_mv/csr_block_matrix.h
)
list (APPEND HYPRE_SOURCES
  parcsr_block_mv/csr_block_matrix.c
  parcsr_block_mv/csr_block_matvec.c
  parcsr_block_mv/par_csr_block_matrix.c
  parcsr_block_mv/par_csr_block_matvec.c
  parcsr_block_mv/par_csr_block_comm.c
  parcsr_block_mv/par_csr_block_rap.c
  parcsr_block_mv/par_csr_block_rap_communication.c
  parcsr_block_mv/par_csr_block_interp.c
  parcsr_block_mv/par_csr_block_relax.c
  parcsr_block_mv/par_block_nodal_systems.c
)

# Headers and sources: distributed_matrix
list (APPEND HYPRE_HEADERS
  distributed_matrix/distributed_matrix.h
)
list (APPEND HYPRE_SOURCES
  distributed_matrix/distributed_matrix.c
  distributed_matrix/HYPRE_distributed_matrix.c
  distributed_matrix/distributed_matrix_ISIS.c
  distributed_matrix/distributed_matrix_PETSc.c
  distributed_matrix/distributed_matrix_parcsr.c
)

# Headers and sources: IJ_mv
list (APPEND HYPRE_HEADERS
  IJ_mv/HYPRE_IJ_mv.h
  IJ_mv/_hypre_IJ_mv.h
)
list (APPEND HYPRE_SOURCES
  IJ_mv/aux_parcsr_matrix.c
  IJ_mv/aux_par_vector.c
  IJ_mv/F90_HYPRE_IJMatrix.c
  IJ_mv/F90_HYPRE_IJVector.c
  IJ_mv/F90_IJMatrix.c
  IJ_mv/HYPRE_IJMatrix.c
  IJ_mv/HYPRE_IJVector.c
  IJ_mv/IJ_assumed_part.c
  IJ_mv/IJMatrix.c
  IJ_mv/IJMatrix_parcsr.c
  IJ_mv/IJVector.c
  IJ_mv/IJVector_parcsr.c
)

# Headers and sources: matrix_matrix
list (APPEND HYPRE_HEADERS
  matrix_matrix/HYPRE_matrix_matrix_protos.h
)
list (APPEND HYPRE_SOURCES
  matrix_matrix/HYPRE_ConvertParCSRMatrixToDistributedMatrix.c
  matrix_matrix/HYPRE_ConvertPETScMatrixToDistributedMatrix.c
)

# Headers and sources: distributed_ls/pilut
list (APPEND HYPRE_HEADERS
  distributed_ls/pilut/HYPRE_DistributedMatrixPilutSolver_protos.h
  distributed_ls/pilut/HYPRE_DistributedMatrixPilutSolver_types.h
)
list (APPEND HYPRE_SOURCES
  distributed_ls/pilut/comm.c
  distributed_ls/pilut/debug.c
  distributed_ls/pilut/distributed_qsort.c
  distributed_ls/pilut/distributed_qsort_si.c
  distributed_ls/pilut/HYPRE_DistributedMatrixPilutSolver.c
  distributed_ls/pilut/ilut.c
  distributed_ls/pilut/parilut.c
  distributed_ls/pilut/parutil.c
  distributed_ls/pilut/pblas1.c
  distributed_ls/pilut/serilut.c
  distributed_ls/pilut/trifactor.c
  distributed_ls/pilut/util.c
)

# Headers and sources: distributed_ls/ParaSails
list (APPEND HYPRE_SOURCES
  distributed_ls/ParaSails/ConjGrad.c
  distributed_ls/ParaSails/DiagScale.c
  distributed_ls/ParaSails/FGmres.c
  distributed_ls/ParaSails/Hash.c
  distributed_ls/ParaSails/hypre_ParaSails.c
  distributed_ls/ParaSails/LoadBal.c
  distributed_ls/ParaSails/Matrix.c
  distributed_ls/ParaSails/Mem.c
  distributed_ls/ParaSails/Numbering.c
  distributed_ls/ParaSails/OrderStat.c
  distributed_ls/ParaSails/ParaSails.c
  distributed_ls/ParaSails/PrunedRows.c
  distributed_ls/ParaSails/RowPatt.c
  distributed_ls/ParaSails/StoredRows.c
)

# Headers and sources: distributed_ls/Euclid
list (APPEND HYPRE_SOURCES
  distributed_ls/Euclid/blas_dh.c
  distributed_ls/Euclid/Euclid_apply.c
  distributed_ls/Euclid/Euclid_dh.c
  distributed_ls/Euclid/ExternalRows_dh.c
  distributed_ls/Euclid/Factor_dh.c
  distributed_ls/Euclid/getRow_dh.c
  distributed_ls/Euclid/globalObjects.c
  distributed_ls/Euclid/Hash_dh.c
  distributed_ls/Euclid/Hash_i_dh.c
  distributed_ls/Euclid/ilu_mpi_bj.c
  distributed_ls/Euclid/ilu_mpi_pilu.c
  distributed_ls/Euclid/ilu_seq.c
  distributed_ls/Euclid/io_dh.c
  distributed_ls/Euclid/krylov_dh.c
  distributed_ls/Euclid/Mat_dh.c
  distributed_ls/Euclid/mat_dh_private.c
  distributed_ls/Euclid/MatGenFD.c
  distributed_ls/Euclid/Mem_dh.c
  distributed_ls/Euclid/Numbering_dh.c
  distributed_ls/Euclid/Parser_dh.c
  distributed_ls/Euclid/shellSort_dh.c
  distributed_ls/Euclid/sig_dh.c
  distributed_ls/Euclid/SortedList_dh.c
  distributed_ls/Euclid/SortedSet_dh.c
  distributed_ls/Euclid/SubdomainGraph_dh.c
  distributed_ls/Euclid/TimeLog_dh.c
  distributed_ls/Euclid/Timer_dh.c
  distributed_ls/Euclid/Vec_dh.c
)

# Headers and sources: parcsr_ls
list (APPEND HYPRE_HEADERS
  parcsr_ls/HYPRE_parcsr_ls.h
  parcsr_ls/_hypre_parcsr_ls.h
)
list (APPEND HYPRE_SOURCES
  parcsr_ls/amg_hybrid.c
  parcsr_ls/aux_interp.c
  parcsr_ls/F90_hypre_laplace.c
  parcsr_ls/F90_HYPRE_parcsr_amg.c

=== src/Makefile ===
#BHEADER**********************************************************************
# Copyright (c) 2008,  Lawrence Livermore National Security, LLC.
# Produced at the Lawrence Livermore National Laboratory.
# This file is part of HYPRE.  See file COPYRIGHT for details.
#
# HYPRE is free software; you can redistribute it and/or modify it under the
# terms of the GNU Lesser General Public License (as published by the Free
# Software Foundation) version 2.1 dated February 1999.
#
# $Revision$
#EHEADER**********************************************************************

default: all

# Include all variables defined by configure
include config/Makefile.config

# These are the directories for internal blas, lapack and general utilities
HYPRE_BASIC_DIRS =\
 blas\
 lapack\
 utilities

#These are the directories for multivector
HYPRE_MULTIVEC_DIRS =\
 multivector

# These are the directories for the generic Krylov solvers
HYPRE_KRYLOV_DIRS =\
 krylov

#These are the directories for the IJ interface
HYPRE_IJ_DIRS =\
 seq_mv\
 parcsr_mv\
 parcsr_block_mv\
 distributed_matrix\
 IJ_mv\
 matrix_matrix\
 parcsr_ls

#These are the directories for the structured interface
HYPRE_STRUCT_DIRS =\
 struct_mv\
 struct_ls

#These are the directories for the semi-structured interface
HYPRE_SSTRUCT_DIRS =\
 sstruct_mv\
 sstruct_ls

#These are the directories for the distributed_ls codes
HYPRE_DISTRIBUTED_LS_DIRS = ${HYPRE_DISTRIBUTED_LS_DIR}

#These are the directories for the FEI
HYPRE_FEI_DIRS = ${HYPRE_FEI_SRC_DIR}

#This is the lib directory
HYPRE_LIBS_DIRS = lib

#This is the documentation directory
HYPRE_DOCS_DIRS = docs

#This is the test-driver directory
HYPRE_TEST_DIRS = test

#This is the examples directory
HYPRE_EXAMPLE_DIRS = examples

# These are directories that are officially in HYPRE
HYPRE_DIRS =\
 ${HYPRE_BASIC_DIRS}\
 ${HYPRE_MULTIVEC_DIRS}\
 ${HYPRE_KRYLOV_DIRS}\
 ${HYPRE_IJ_DIRS}\
 ${HYPRE_STRUCT_DIRS}\
 ${HYPRE_SSTRUCT_DIRS}\
 ${HYPRE_DISTRIBUTED_LS_DIRS}\
 ${HYPRE_FEI_DIRS}\
 ${HYPRE_LIBS_DIRS}

# These are directories that are not yet officially in HYPRE
HYPRE_EXTRA_DIRS =\
 ${HYPRE_DOCS_DIRS}\
 ${HYPRE_TEST_DIRS}\
 seq_ls/pamg

#################################################################
# Targets
#################################################################

all:
	@ \
	mkdir -p ${HYPRE_BUILD_DIR}/include; \
	mkdir -p ${HYPRE_BUILD_DIR}/lib; \
	cp -fR HYPRE_config.h ${HYPRE_BUILD_DIR}/include/.; \
	cp -fR $(srcdir)/HYPRE.h ${HYPRE_BUILD_DIR}/include/.; \
	cp -fR $(srcdir)/HYPREf.h ${HYPRE_BUILD_DIR}/include/.; \
	for i in ${HYPRE_DIRS}; \
	do \
	  echo "Making $$i ..."; \
	  (cd $$i && $(MAKE) $@) || exit 1; \
	  echo ""; \
	done

help:
	@echo "     "
	@echo "************************************************************"
	@echo " HYPRE Make System Targets"
	@echo "   (using GNU-standards)"
	@echo "     "
	@echo "all:"
	@echo "     default target in all directories"
	@echo "     compile the entire program"
	@echo "     does not rebuild documentation"
	@echo "     "
	@echo "help:"
	@echo "     prints details of each target"
	@echo "     "
	@echo "install:"
	@echo "     compile the program and copy executables, libraries, etc"
	@echo "        to the file names where they reside for actual use"
	@echo "     executes mkinstalldirs script to create directories needed"
	@echo "     "
	@echo "clean:"
	@echo "     deletes all files from the current directory that are normally"
	@echo "        created by building the program"
	@echo "     "
	@echo "distclean:"
	@echo "     deletes all files from the current directory that are"
	@echo "        created by configuring or building the program"
	@echo "     "
	@echo "tags:"
	@echo "     runs etags to create tags table"
	@echo "     file is named TAGS and is saved in current directory"
	@echo "     "
	@echo "test:"
	@echo "     depends on the all target to be completed"
	@echo "     removes existing temporary installation sub-directory"
	@echo "     creates a temporary installation sub-directory"
	@echo "     copies all libHYPRE* and *.h files to the temporary locations"
	@echo "     builds the test drivers; linking to the temporary installation"
	@echo "        directories to simulate how application codes will link to HYPRE"
	@echo "     "
	@echo "check:"
	@echo "     runs a small driver test to verify a working library"
	@echo "     use CHECKRUN=<mpirun routine> if needed combined with"
	@echo "     PARMS='-P px py pz' where px*py*pz must be number of"
	@echo "     processes set in CHECKRUN"
	@echo "     "
	@echo "     "
	@echo "checkpar:"
	@echo "     runs several regression test to verify a working library."
	@echo "     Use parameter CHECKRUN='<mpirun routine -n>' if needed."
	@echo "     If CHECKRUN is not set, 'mpirun -np' is used."
	@echo "     "
	@echo "     "
	@echo "************************************************************"

test: all
	@ \
	echo "Making test drivers ..."; \
	(cd test; $(MAKE) clean; $(MAKE) all)

check:
	@ \
	echo "Checking the library ..."; \
	(cd test; $(MAKE) all); \
	(cd test; $(CHECKRUN) ./ij $(PARMS) 2> ij.err); \
	(cd test; $(CHECKRUN) ./struct $(PARMS) 2> struct.err); \
	(cd test; cp -f TEST_sstruct/sstruct.in.default .; $(CHECKRUN) ./sstruct $(PARMS) 2> sstruct.err); \
	(cd test; ls -l ij.err struct.err sstruct.err)

checkpar:
	@ \
        echo "Checking the library ..."; \
        (cd test; $(MAKE) all); \
        echo "Testing IJ ..."; \
        (cd test; ./runtest.sh -tol 1.e-06 -mpi "$(CHECKRUN)" TEST_ij/solvers.sh); \
        (cd test; ./checktest.sh); \
        (cd test; ./cleantest.sh); \
        echo "Testing Struct ..."; \
        (cd test; ./runtest.sh -tol 1.e-06 -mpi "$(CHECKRUN)" TEST_struct/solvers.sh); \
        (cd test; ./checktest.sh); \
        (cd test; ./cleantest.sh); \
        echo "Testing SStruct ..."; \
        (cd test; ./runtest.sh -tol 1.e-06 -mpi "$(CHECKRUN)" TEST_sstruct/solvers.sh); \
        (cd test; ./checktest.sh); \
        (cd test; ./cleantest.sh); 

install: all
	@ \
	echo "Installing hypre ..."; \
	${HYPRE_SRC_TOP_DIR}/config/mkinstalldirs ${HYPRE_LIB_INSTALL} ${HYPRE_INC_INSTALL}; \
	HYPRE_PWD=`pwd`; \
	cd ${HYPRE_BUILD_DIR}/lib; HYPRE_FROMDIR=`pwd`; \
	cd $$HYPRE_PWD; \
	cd ${HYPRE_LIB_INSTALL};   HYPRE_TODIR=`pwd`; \
	if [ "$$HYPRE_FROMDIR" != "$$HYPRE_TODIR" ]; \
	then \
	  cp -fR $$HYPRE_FROMDIR/* $$HYPRE_TODIR; \
	fi; \
	cd ${HYPRE_BUILD_DIR}/include; HYPRE_FROMDIR=`pwd`; \
	cd $$HYPRE_PWD; \
	cd ${HYPRE_INC_INSTALL};       HYPRE_TODIR=`pwd`; \
	if [ "$$HYPRE_FROMDIR" != "$$HYPRE_TODIR" ]; \
	then \
	  cp -fR $$HYPRE_FROMDIR/* $$HYPRE_TODIR; \
	fi; \
	cd $$HYPRE_PWD; \
	chmod -R a+rX,u+w,go-w ${HYPRE_LIB_INSTALL}; \
	chmod -R a+rX,u+w,go-w ${HYPRE_INC_INSTALL}; \
	echo

clean:
	@ \
	rm -Rf hypre; \
	for i in ${HYPRE_DIRS} ${HYPRE_EXTRA_DIRS} ${HYPRE_EXAMPLE_DIRS}; \
	do \
	  if [ -f $$i/Makefile ]; \
	  then \
	    echo "Cleaning $$i ..."; \
	    (cd $$i && $(MAKE) $@) || exit 1; \
	  fi; \
	done
	rm -rf tca.map pchdir *inslog*

distclean:
	@ \
	rm -Rf hypre; \
	for i in ${HYPRE_DIRS} ${HYPRE_EXTRA_DIRS} ${HYPRE_EXAMPLE_DIRS} examples/docs; \
	do \
	  if [ -d $$i ]; \
	  then \
	    echo "Dist-Cleaning $$i ..."; \
	    (cd $$i && $(MAKE) $@) || exit 1; \
	  fi; \
	done
	rm -rf tca.map pchdir *inslog*
	rm -rf ./config/Makefile.config
	rm -rf ./TAGS
	rm -rf ./autom4te.cache
	rm -rf ./config.log
	rm -rf ./config.status
	rm -rf ./HYPRE_config.h

tags:
	find . -name "*.c" -o -name "*.C" -o -name "*.h" -o \
	-name "*.c??" -o -name "*.h??" -o -name "*.f" | etags -

=== src/docs/Makefile ===
#BHEADER**********************************************************************
# Copyright (c) 2008,  Lawrence Livermore National Security, LLC.
# Produced at the Lawrence Livermore National Laboratory.
# This file is part of HYPRE.  See file COPYRIGHT for details.
#
# HYPRE is free software; you can redistribute it and/or modify it under the
# terms of the GNU Lesser General Public License (as published by the Free
# Software Foundation) version 2.1 dated February 1999.
#
# $Revision$
#EHEADER**********************************************************************

include ../config/Makefile.config

.SUFFIXES:
.SUFFIXES: .c .dxx .html .tex

##################################################################
# Targets
##################################################################

all: html pdf

install: all
	@ \
	test ! -d ${HYPRE_INSTALL_DIR}/docs && \
	    mkdir -m 755 -p ${HYPRE_INSTALL_DIR}/docs; \
	for dir in HYPRE_usr_manual HYPRE_ref_manual; do \
	  if test -d $$dir; then \
	    test ! -d ${HYPRE_INSTALL_DIR}/docs/$$dir && \
		mkdir -m 755 -p ${HYPRE_INSTALL_DIR}/docs/$$dir; \
	    for file in $$dir/*; do \
	      cp -fp $$file ${HYPRE_INSTALL_DIR}/docs/$$file; \
	    done; \
	  fi; \
	done; \
	for file in HYPRE_usr_manual.pdf HYPRE_ref_manual.pdf; do \
	  test -f $$file && cp -fp $$file ${HYPRE_INSTALL_DIR}/docs/$$file; \
	done

clean:
	@cd usr-manual; make clean
	@cd ref-manual; make clean
	@/bin/rm -fr usr-manual-html ref-manual-html
	@/bin/rm -fr usr-manual.pdf  ref-manual.pdf

distclean: clean

##################################################################
# Rules
##################################################################

html: usr-html ref-html

pdf: usr-pdf ref-pdf

usr: usr-html usr-pdf
usr-html:
	@cd usr-manual; make html
	@mv usr-manual/_build/html usr-manual-html
usr-pdf:
	@cd usr-manual; make latexpdf
	@mv usr-manual/_build/latex/hypre.pdf usr-manual.pdf

ref: ref-html ref-pdf
ref-html:
	@cd ref-manual; make html
	@mv ref-manual/html ref-manual-html
ref-pdf:
	@cd ref-manual; make pdf
	@mv ref-manual/latex/refman.pdf ref-manual.pdf

##########

vref_manual.tex: vref_manual.dxx
	doc++ -t -o vref_manual.tex vref_manual.dxx
	mv vref_manual.tex vref_manual.tmp
	sed 's/HYPRE\\_Int\([^a-zA-Z_0-9]\)/int\1/g' vref_manual.tmp > vref_manual.tex

vref_manual.dxx: ref_manual.dxx
	@ \
	sed -e '/HYPRECopyright/r copyright.txt' -e 's/HYPRECopyright//g' -e 's/HYPREVersion/$(HYPRE_RELEASE_VERSION)/g' ref_manual.dxx > vref_manual.dxx

##########

version.tex:
	@ \
	echo "\def\HYPREVersion{$(HYPRE_RELEASE_VERSION)}" > version.tex; \
	echo "\def\HYPREVersionDate{$(HYPRE_RELEASE_DATE)}" >> version.tex

=== src/krylov/Makefile ===
#BHEADER**********************************************************************
# Copyright (c) 2008,  Lawrence Livermore National Security, LLC.
# Produced at the Lawrence Livermore National Laboratory.
# This file is part of HYPRE.  See file COPYRIGHT for details.
#
# HYPRE is free software; you can redistribute it and/or modify it under the
# terms of the GNU Lesser General Public License (as published by the Free
# Software Foundation) version 2.1 dated February 1999.
#
# $Revision$
#EHEADER**********************************************************************


include ../config/Makefile.config

CINCLUDES = ${INCLUDES} ${MPIINCLUDE}
 
C_COMPILE_FLAGS = \
 -I..\
 -I$(srcdir)/..\
 -I$(srcdir)/../blas\
 -I$(srcdir)/../lapack\
 -I$(srcdir)/../multivector\
 -I$(srcdir)/../utilities\
 ${CINCLUDES}

HEADERS =\
 HYPRE_krylov.h\
 krylov.h\
 bicgstab.h\
 cgnr.h\
 gmres.h\
 cogmres.h\
 flexgmres.h\
 lgmres.h\
 pcg.h\
 HYPRE_lobpcg.h\
 HYPRE_MatvecFunctions.h\
 lobpcg.h

FILES =\
 bicgstab.c\
 cgnr.c\
 gmres.c\
 cogmres.c\
 flexgmres.c\
 lgmres.c\
 HYPRE_bicgstab.c\
 HYPRE_cgnr.c\
 HYPRE_gmres.c\
 HYPRE_cogmres.c\
 HYPRE_lgmres.c\
 HYPRE_flexgmres.c\
 HYPRE_pcg.c\
 pcg.c\
 HYPRE_lobpcg.c\
 lobpcg.c

OBJS = ${FILES:.c=.o}

SONAME = libHYPRE_krylov-${HYPRE_RELEASE_VERSION}${HYPRE_LIB_SUFFIX}

##################################################################
# Targets
##################################################################

all: libHYPRE_krylov${HYPRE_LIB_SUFFIX}
	cp -fR $(srcdir)/HYPRE_*.h $(HYPRE_BUILD_DIR)/include
	cp -fR $(srcdir)/krylov.h $(HYPRE_BUILD_DIR)/include
	cp -fR $(srcdir)/lobpcg.h $(HYPRE_BUILD_DIR)/include
#	cp -fR libHYPRE* $(HYPRE_BUILD_DIR)/lib

install: all
	cp -fR $(srcdir)/HYPRE_*.h $(HYPRE_INC_INSTALL)
	cp -fR $(srcdir)/krylov.h $(HYPRE_INC_INSTALL)
	cp -fR $(srcdir)/lobpcg.h $(HYPRE_INC_INSTALL)
#	cp -fR libHYPRE* $(HYPRE_LIB_INSTALL)

clean:
	rm -f *.o libHYPRE*
	rm -rf pchdir tca.map *inslog*

distclean: clean

##################################################################
# Rules
##################################################################

libHYPRE_krylov.a: ${OBJS}
	@echo  "Building $@ ... "
	${AR} $@ ${OBJS}
	${RANLIB} $@

libHYPRE_krylov.so libHYPRE_krylov.dylib: ${OBJS}
	@echo  "Building $@ ... "
	${BUILD_CC_SHARED} -o ${SONAME} ${OBJS} ${SHARED_SET_SONAME}${SONAME}
	ln -s ${SONAME} $@

${OBJS}: ${HEADERS}

=== src/lib/Makefile ===
#BHEADER**********************************************************************
# Copyright (c) 2008,  Lawrence Livermore National Security, LLC.
# Produced at the Lawrence Livermore National Laboratory.
# This file is part of HYPRE.  See file COPYRIGHT for details.
#
# HYPRE is free software; you can redistribute it and/or modify it under the
# terms of the GNU Lesser General Public License (as published by the Free
# Software Foundation) version 2.1 dated February 1999.
#
# $Revision$
#EHEADER**********************************************************************

include ../config/Makefile.config

FEIHYPREFILES = ${HYPRE_FEI_HYPRE_FILES}
FEMLIFILES = ${HYPRE_FEI_FEMLI_FILES}
IJMVFILES = ${HYPRE_SRC_TOP_DIR}/IJ_mv/*.o
EUCLIDFILES = ${HYPRE_EUCLID_FILES}
PARASAILSFILES = ${HYPRE_PARASAILS_FILES}
PILUTFILES = ${HYPRE_PILUT_FILES}
DISTMATRIXFILES = ${HYPRE_SRC_TOP_DIR}/distributed_matrix/*.o
KRYLOVFILES = ${HYPRE_SRC_TOP_DIR}/krylov/*.o
MATMATFILES = ${HYPRE_SRC_TOP_DIR}/matrix_matrix/*.o
MULTIVECFILES = ${HYPRE_SRC_TOP_DIR}/multivector/*.o
PARCSRLSFILES = ${HYPRE_SRC_TOP_DIR}/parcsr_ls/*.o
PARCSRMVFILES = ${HYPRE_SRC_TOP_DIR}/parcsr_mv/*.o
PARCSRBLOCKMVFILES = ${HYPRE_SRC_TOP_DIR}/parcsr_block_mv/*.o
SEQMVFILES = ${HYPRE_SRC_TOP_DIR}/seq_mv/*.o
SSTRUCTLSFILES = ${HYPRE_SRC_TOP_DIR}/sstruct_ls/*.o
SSTRUCTMVFILES = ${HYPRE_SRC_TOP_DIR}/sstruct_mv/*.o
STRUCTLSFILES = ${HYPRE_SRC_TOP_DIR}/struct_ls/*.o
STRUCTMVFILES = ${HYPRE_SRC_TOP_DIR}/struct_mv/*.o
UTILITIESFILES = ${HYPRE_SRC_TOP_DIR}/utilities/*.o
BLASFILES = ${HYPRE_SRC_TOP_DIR}/blas/*.o
LAPACKFILES = ${HYPRE_SRC_TOP_DIR}/lapack/*.o

FILES_HYPRE = \
$(FEIHYPREFILES)\
$(FEMLIFILES)\
$(IJMVFILES)\
$(EUCLIDFILES)\
$(PARASAILSFILES)\
$(PILUTFILES)\
$(DISTMATRIXFILES)\
$(KRYLOVFILES)\
$(MATMATFILES)\
$(MULTIVECFILES)\
$(PARCSRLSFILES)\
$(PARCSRMVFILES)\
$(PARCSRBLOCKMVFILES)\
$(SEQMVFILES)\
$(SSTRUCTLSFILES)\
$(SSTRUCTMVFILES)\
$(STRUCTLSFILES)\
$(STRUCTMVFILES)\
$(UTILITIESFILES)\
$(BLASFILES)\
$(LAPACKFILES)

SONAME = libHYPRE-${HYPRE_RELEASE_VERSION}${HYPRE_LIB_SUFFIX}
SOLIBS = ${MPILIBDIRS} ${MPILIBS} ${LAPACKLIBDIRS} ${LAPACKLIBS}\
 ${BLASLIBDIRS} ${BLASLIBS} ${LIBS} ${FLIBS}


##################################################################
# Targets
##################################################################

all: libHYPRE${HYPRE_LIB_SUFFIX}
	cp -fR libHYPRE* ${HYPRE_BUILD_DIR}/lib

install: all
	cp -fR libHYPRE* ${HYPRE_LIB_INSTALL}

clean:
	rm -f *.o libHYPRE*
	rm -rf pchdir tca.map *inslog*

distclean: clean

##################################################################
# Rules
##################################################################

libHYPRE.a: ${FILES_HYPRE}
	@echo  "Building libHYPRE ... "
	rm -f $@
	${AR} $@ $(FEIHYPREFILES) $(FEMLIFILES) $(IJMVFILES)
	${AR} $@ $(EUCLIDFILES)
	${AR} $@ $(PARASAILSFILES)
	${AR} $@ $(PILUTFILES)
	${AR} $@ $(DISTMATRIXFILES)
	${AR} $@ $(KRYLOVFILES)
	${AR} $@ $(MATMATFILES)
	${AR} $@ $(MULTIVECFILES)
	${AR} $@ $(PARCSRLSFILES)
	${AR} $@ $(PARCSRMVFILES)
	${AR} $@ $(PARCSRBLOCKMVFILES)
	${AR} $@ $(SEQMVFILES)
	${AR} $@ $(SSTRUCTLSFILES)
	${AR} $@ $(SSTRUCTMVFILES)
	${AR} $@ $(STRUCTLSFILES)
	${AR} $@ $(STRUCTMVFILES)
	${AR} $@ $(UTILITIESFILES) $(BLASFILES) $(LAPACKFILES)
	${RANLIB} $@

libHYPRE.so libHYPRE.dylib: ${FILES_HYPRE}
	@echo  "Building $@ ... "
	${BUILD_CC_SHARED} -o ${SONAME} ${FILES_HYPRE} ${SOLIBS} ${SHARED_SET_SONAME}${SONAME} ${SHARED_OPTIONS} ${LDFLAGS}
	ln -s ${SONAME} $@

=== src/matrix_matrix/Makefile ===
#BHEADER**********************************************************************
# Copyright (c) 2008,  Lawrence Livermore National Security, LLC.
# Produced at the Lawrence Livermore National Laboratory.
# This file is part of HYPRE.  See file COPYRIGHT for details.
#
# HYPRE is free software; you can redistribute it and/or modify it under the
# terms of the GNU Lesser General Public License (as published by the Free
# Software Foundation) version 2.1 dated February 1999.
#
# $Revision$
#EHEADER**********************************************************************


include ../config/Makefile.config

CINCLUDES = ${INCLUDES} ${MPIINCLUDE}

C_COMPILE_FLAGS = \
 -I..\
 -I$(srcdir)/..\
 -I$(srcdir)/../utilities\
 -I$(srcdir)/../distributed_matrix\
 -I$(srcdir)/../seq_mv\
 -I$(srcdir)/../parcsr_mv\
 ${CINCLUDES}

EXTRA_FILES =\
 internal_protos.h

HEADERS = HYPRE_matrix_matrix_protos.h
 
FILES =\
 HYPRE_ConvertParCSRMatrixToDistributedMatrix.c\
 HYPRE_ConvertPETScMatrixToDistributedMatrix.c

OBJS = ${FILES:.c=.o}

SONAME = libHYPRE_MatrixMatrix-${HYPRE_RELEASE_VERSION}${HYPRE_LIB_SUFFIX}

##################################################################
# Targets
##################################################################

all: libHYPRE_MatrixMatrix${HYPRE_LIB_SUFFIX}
	cp -fR $(srcdir)/HYPRE_*.h $(HYPRE_BUILD_DIR)/include
#	cp -fR libHYPRE* $(HYPRE_BUILD_DIR)/lib

install: libHYPRE_MatrixMatrix${HYPRE_LIB_SUFFIX}
	cp -fR $(srcdir)/HYPRE_*.h $(HYPRE_INC_INSTALL)
#	cp -fR libHYPRE* $(HYPRE_LIB_INSTALL)

clean:
	rm -f *.o lib*
	rm -rf pchdir tca.map *inslog*

distclean: clean

##################################################################
# Rules
##################################################################

libHYPRE_MatrixMatrix.a: ${OBJS}
	@echo  "Building $@ ... "
	${AR} $@ ${OBJS}
	${RANLIB} $@

libHYPRE_MatrixMatrix.so libHYPRE_MatrixMatrix.dylib: ${OBJS}
	@echo  "Building $@ ... "
	${BUILD_CC_SHARED} -o ${SONAME} ${OBJS} ${SHARED_SET_SONAME}${SONAME}
	ln -s ${SONAME} $@

${OBJS}: ${HEADERS}

=== src/multivector/Makefile ===
#BHEADER**********************************************************************
# Copyright (c) 2008,  Lawrence Livermore National Security, LLC.
# Produced at the Lawrence Livermore National Laboratory.
# This file is part of HYPRE.  See file COPYRIGHT for details.
#
# HYPRE is free software; you can redistribute it and/or modify it under the
# terms of the GNU Lesser General Public License (as published by the Free
# Software Foundation) version 2.1 dated February 1999.
#
# $Revision$
#EHEADER**********************************************************************


include ../config/Makefile.config

CINCLUDES = ${INCLUDES} ${MPIINCLUDE}

C_COMPILE_FLAGS = \
 -I.\
 -I$(srcdir)/..\
 -I$(srcdir)/../utilities\
 ${CINCLUDES}

HEADERS =\
 multivector.h\
 temp_multivector.h

FILES =\
 multivector.c\
 temp_multivector.c

OBJS = ${FILES:.c=.o}

SONAME = libHYPRE_multivector-${HYPRE_RELEASE_VERSION}${HYPRE_LIB_SUFFIX}

##################################################################
# Targets
##################################################################

all: libHYPRE_multivector${HYPRE_LIB_SUFFIX}
	cp -fR *.h $(HYPRE_BUILD_DIR)/include
#	cp -fR libHYPRE* $(HYPRE_BUILD_DIR)/lib

install: libHYPRE_multivector${HYPRE_LIB_SUFFIX}
	cp -fR *.h $(HYPRE_INC_INSTALL)
#	cp -fR libHYPRE* $(HYPRE_LIB_INSTALL)

clean:
	rm -f *.o libHYPRE*
	rm -rf pchdir tca.map *inslog*

distclean: clean

##################################################################
# Rules
##################################################################

libHYPRE_multivector.a: ${OBJS}
	@echo  "Building $@ ... "
	${AR} $@ ${OBJS}
	${RANLIB} $@

libHYPRE_multivector.so libHYPRE_multivector.dylib: ${OBJS}
	@echo  "Building $@ ... "
	${BUILD_CC_SHARED} -o ${SONAME} ${OBJS} ${SHARED_SET_SONAME}${SONAME}
	ln -s ${SONAME} $@

${OBJS}: ${HEADERS}

=== src/parcsr_ls/Makefile ===
#BHEADER**********************************************************************
# Copyright (c) 2008,  Lawrence Livermore National Security, LLC.
# Produced at the Lawrence Livermore National Laboratory.
# This file is part of HYPRE.  See file COPYRIGHT for details.
#
# HYPRE is free software; you can redistribute it and/or modify it under the
# terms of the GNU Lesser General Public License (as published by the Free
# Software Foundation) version 2.1 dated February 1999.
#
# $Revision$
#EHEADER**********************************************************************

include ../config/Makefile.config

## Euclid specific macros taken from distributed_ls/Euclid

CINCLUDES = ${INCLUDES} ${MPIINCLUDE}

C_COMPILE_FLAGS =\
 -I..\
 -I../distributed_ls/Euclid\
 -I$(srcdir)\
 -I$(srcdir)/..\
 -I$(srcdir)/../blas\
 -I$(srcdir)/../lapack\
 -I$(srcdir)/../multivector\
 -I$(srcdir)/../utilities\
 -I$(srcdir)/../krylov\
 -I$(srcdir)/../seq_mv\
 -I$(srcdir)/../parcsr_mv\
 -I$(srcdir)/../distributed_matrix\
 -I$(srcdir)/../matrix_matrix\
 -I$(srcdir)/../IJ_mv\
 -I$(srcdir)/../parcsr_block_mv\
 $(DSUPERLU_INCLUDE)\
 ${CINCLUDES}

HEADERS =\
 HYPRE_parcsr_ls.h\
 _hypre_parcsr_ls.h\
 aux_interp.h\
 block_tridiag.h\
 Common.h\
 par_amg.h\
 schwarz.h

FILES =\
 amg_hybrid.c\
 aux_interp.c\
 F90_hypre_laplace.c\
 F90_HYPRE_parcsr_amg.c\
 F90_HYPRE_parcsr_bicgstab.c\
 F90_HYPRE_parcsr_block.c\
 F90_HYPRE_parcsr_cgnr.c\
 F90_HYPRE_parcsr_Euclid.c\
 F90_HYPRE_parcsr_gmres.c\
 F90_HYPRE_parcsr_cogmres.c\
 F90_HYPRE_parcsr_flexgmres.c\
 F90_HYPRE_parcsr_lgmres.c\
 F90_HYPRE_parcsr_hybrid.c\
 F90_HYPRE_parcsr_int.c\
 F90_HYPRE_parcsr_ParaSails.c\
 F90_HYPRE_parcsr_pcg.c\
 F90_HYPRE_parcsr_pilut.c\
 F90_HYPRE_parcsr_schwarz.c\
 F90_HYPRE_ams.c\
 gen_redcs_mat.c\
 HYPRE_parcsr_amg.c\
 HYPRE_parcsr_bicgstab.c\
 HYPRE_parcsr_block.c\
 HYPRE_parcsr_cgnr.c\
 HYPRE_parcsr_Euclid.c\
 HYPRE_parcsr_gmres.c\
 HYPRE_parcsr_cogmres.c\
 HYPRE_parcsr_flexgmres.c\
 HYPRE_parcsr_lgmres.c\
 HYPRE_parcsr_hybrid.c\
 HYPRE_parcsr_int.c\
 HYPRE_parcsr_mgr.c\
 HYPRE_parcsr_ParaSails.c\
 HYPRE_parcsr_pcg.c\
 HYPRE_parcsr_pilut.c\
 HYPRE_parcsr_schwarz.c\
 HYPRE_ams.c\
 HYPRE_ads.c\
 HYPRE_ame.c\
 par_amg.c\
 par_amg_setup.c\
 par_amg_solve.c\
 par_amg_solveT.c\
 par_cg_relax_wt.c\
 par_coarsen.c\
 par_cgc_coarsen.c\
 par_cheby.c\
 par_coarse_parms.c\
 par_coordinates.c\
 par_cr.c\
 par_cycle.c\
 par_add_cycle.c\
 par_difconv.c\
 par_gsmg.c\
 par_indepset.c\
 par_interp.c\
 par_jacobi_interp.c\
 par_multi_interp.c\
 par_laplace.c\
 par_laplace_27pt.c\
 par_laplace_9pt.c\
 par_lr_interp.c\
 par_mgr.c\
 par_mgr_setup.c\
 par_mgr_solve.c\
 par_nongalerkin.c\
 par_nodal_systems.c\
 par_rap.c\
 par_rap_communication.c\
 par_rotate_7pt.c\
 par_relax.c\
 par_relax_more.c\
 par_relax_interface.c\
 par_scaled_matnorm.c\
 par_schwarz.c\
 par_stats.c\
 par_strength.c\
 par_sv_interp.c\
 par_sv_interp_ln.c\
 par_vardifconv.c\
 par_vardifconv_rs.c\
 partial.c\
 pcg_par.c\
 schwarz.c\
 block_tridiag.c\
 ams.c\
 ads.c\
 ame.c\
 par_restr.c\
 par_lr_restr.c\
 superlu.c

OBJS = ${FILES:.c=.o}

SONAME = libHYPRE_parcsr_ls-${HYPRE_RELEASE_VERSION}${HYPRE_LIB_SUFFIX}

##################################################################
# Targets
##################################################################

all: libHYPRE_parcsr_ls${HYPRE_LIB_SUFFIX}
	cp -fR $(srcdir)/HYPRE_*.h $(HYPRE_BUILD_DIR)/include
	cp -fR $(srcdir)/_hypre_parcsr_ls.h $(HYPRE_BUILD_DIR)/include
#	cp -fR libHYPRE* $(HYPRE_BUILD_DIR)/lib

install: libHYPRE_parcsr_ls${HYPRE_LIB_SUFFIX}
	cp -fR $(srcdir)/HYPRE_*.h $(HYPRE_INC_INSTALL)
	cp -fR $(srcdir)/_hypre_parcsr_ls.h $(HYPRE_INC_INSTALL)
#	cp -fR libHYPRE* $(HYPRE_LIB_INSTALL)

clean:
	rm -f *.o libHYPRE*
	rm -rf pchdir tca.map *inslog*

distclean: clean


##################################################################
# Rules
##################################################################

libHYPRE_parcsr_ls.a: ${OBJS}
	@echo  "Building $@ ... "
	${AR} $@ ${OBJS}
	${RANLIB} $@

libHYPRE_parcsr_ls.so libHYPRE_parcsr_ls.dylib: ${OBJS}
	@echo  "Building $@ ... "
	${BUILD_CC_SHARED} -o ${SONAME} ${OBJS} ${SHARED_SET_SONAME}${SONAME}
	ln -s ${SONAME} $@

${OBJS}: ${HEADERS}

=== src/parcsr_mv/Makefile ===
#BHEADER**********************************************************************
# Copyright (c) 2008,  Lawrence Livermore National Security, LLC.
# Produced at the Lawrence Livermore National Laboratory.
# This file is part of HYPRE.  See file COPYRIGHT for details.
#
# HYPRE is free software; you can redistribute it and/or modify it under the
# terms of the GNU Lesser General Public License (as published by the Free
# Software Foundation) version 2.1 dated February 1999.
#
# $Revision$
#EHEADER**********************************************************************


include ../config/Makefile.config

CINCLUDES = ${INCLUDES} ${MPIINCLUDE}

C_COMPILE_FLAGS = \
 -I..\
 -I$(srcdir)\
 -I$(srcdir)/..\
 -I$(srcdir)/../blas\
 -I$(srcdir)/../lapack\
 -I$(srcdir)/../utilities\
 -I$(srcdir)/../seq_mv\
 ${CINCLUDES}

HEADERS =\
 HYPRE_parcsr_mv.h\
 _hypre_parcsr_mv.h\
 new_commpkg.h\
 numbers.h\
 par_chord_matrix.h\
 par_csr_communication.h\
 par_csr_matrix.h\
 par_vector.h

FILES =\
 communicationT.c\
 F90_HYPRE_parcsr_matrix.c\
 F90_HYPRE_parcsr_vector.c\
 F90_parcsr_matrix.c\
 F90_par_vector.c\
 HYPRE_parcsr_matrix.c\
 HYPRE_parcsr_vector.c\
 new_commpkg.c\
 numbers.c\
 par_csr_aat.c\
 par_csr_assumed_part.c\
 par_csr_bool_matop.c\
 par_csr_bool_matrix.c\
 par_csr_communication.c\
 par_csr_matop.c\
 par_csr_matrix.c\
 par_csr_matop_marked.c\
 par_csr_matvec.c\
 par_vector.c\
 par_make_system.c

EXTRA_FILES =\
 parchord_to_parcsr.c

DRIVER_FILES =\
 driver_aat.c\
 driver_boolaat.c\
 driver_boolmatmul.c\
 driver.c\
 driver_matmul.c\
 driver_mat_multivec.c\
 driver_matvec.c\
 driver_multivec.c

OBJS = ${FILES:.c=.o}
DRIVER_OBJS = ${DRIVER_FILES:.c=.o}

SONAME = libHYPRE_parcsr_mv-${HYPRE_RELEASE_VERSION}${HYPRE_LIB_SUFFIX}

##################################################################
# Targets
##################################################################

all: libHYPRE_parcsr_mv${HYPRE_LIB_SUFFIX}
	cp -fR $(srcdir)/HYPRE_*.h $(HYPRE_BUILD_DIR)/include
	cp -fR $(srcdir)/_hypre_parcsr_mv.h $(HYPRE_BUILD_DIR)/include
#	cp -fR libHYPRE* $(HYPRE_BUILD_DIR)/lib

driver: driver.o libHYPRE_parcsr_mv${HYPRE_LIB_SUFFIX} 
	@echo  "Linking" $@ "... "
	${CC} -o driver driver.o ${LFLAGS} 

driver_matvec: driver_matvec.o libHYPRE_parcsr_mv${HYPRE_LIB_SUFFIX}
	@echo  "Linking" $@ "... "
	${CC} -o driver_matvec driver_matvec.o ${LFLAGS} 

driver_matmul: driver_matmul.o libHYPRE_parcsr_mv${HYPRE_LIB_SUFFIX}
	@echo  "Linking" $@ "... "
	${CC} -o driver_matmul driver_matmul.o ${LFLAGS} 

driver_boolmatmul: driver_boolmatmul.o libHYPRE_parcsr_mv${HYPRE_LIB_SUFFIX}
	@echo  "Linking" $@ "... "
	${CC} -o driver_boolmatmul driver_boolmatmul.o ${LFLAGS} 

driver_aat: driver_aat.o libHYPRE_parcsr_mv${HYPRE_LIB_SUFFIX}
	@echo  "Linking" $@ "... "
	${CC} -o driver_aat driver_aat.o ${LFLAGS} 

driver_boolaat: driver_boolaat.o libHYPRE_parcsr_mv${HYPRE_LIB_SUFFIX}
	@echo  "Linking" $@ "... "
	${CC} -o driver_boolaat driver_boolaat.o ${LFLAGS} 

install: libHYPRE_parcsr_mv${HYPRE_LIB_SUFFIX}
	cp -fR $(srcdir)/HYPRE_*.h $(HYPRE_INC_INSTALL)
	cp -fR $(srcdir)/_hypre_parcsr_mv.h $(HYPRE_INC_INSTALL)
#	cp -fR libHYPRE* $(HYPRE_LIB_INSTALL)

clean:
	rm -f *.o libHYPRE*
	rm -f driver driver_matvec driver_matmul
	rm -rf pchdir tca.map *inslog*

distclean: clean

##################################################################
# Rules
##################################################################

libHYPRE_parcsr_mv.a: ${OBJS}
	@echo  "Building $@ ... "
	${AR} $@ ${OBJS}
	${RANLIB} $@

libHYPRE_parcsr_mv.so libHYPRE_parcsr_mv.dylib: ${OBJS}
	@echo  "Building $@ ... "
	${BUILD_CC_SHARED} -o ${SONAME} ${OBJS} ${SHARED_SET_SONAME}${SONAME}
	ln -s ${SONAME} $@

${OBJS}: ${HEADERS}

${DRIVER_OBJS}: ${HEADERS}

=== src/seq_mv/Makefile ===
#BHEADER**********************************************************************
# Copyright (c) 2008,  Lawrence Livermore National Security, LLC.
# Produced at the Lawrence Livermore National Laboratory.
# This file is part of HYPRE.  See file COPYRIGHT for details.
#
# HYPRE is free software; you can redistribute it and/or modify it under the
# terms of the GNU Lesser General Public License (as published by the Free
# Software Foundation) version 2.1 dated February 1999.
#
# $Revision$
#EHEADER**********************************************************************


include ../config/Makefile.config

#FILES_NVCC = gpukernels.cu
#include $(HYPRE_NVCC_MAKEFILE)

CINCLUDES = ${INCLUDES} ${MPIINCLUDE}

C_COMPILE_FLAGS =\
 -I..\
 -I$(srcdir)\
 -I$(srcdir)/..\
 -I$(srcdir)/../utilities\
 ${CINCLUDES}

CU_COMPILE_FLAGS = ${C_COMPILE_FLAGS}

HEADERS =\
 csr_matrix.h\
 HYPRE_seq_mv.h\
 mapped_matrix.h\
 multiblock_matrix.h\
 seq_mv.h\
 vector.h

FILES =\
 csr_matop.c\
 csr_matrix.c\
 csr_matvec.c\
 genpart.c\
 HYPRE_csr_matrix.c\
 HYPRE_mapped_matrix.c\
 HYPRE_multiblock_matrix.c\
 HYPRE_vector.c\
 mapped_matrix.c\
 multiblock_matrix.c\
 vector.c\
 csr_matvec_oomp.c\
 gpukernels.c

OBJS = ${FILES:.c=.o}
#CUOBJS = ${FILES_NVCC:.cu=.o}

SONAME = libHYPRE_seq_mv-${HYPRE_RELEASE_VERSION}${HYPRE_LIB_SUFFIX}

##################################################################
# Targets
##################################################################

all: libHYPRE_seq_mv${HYPRE_LIB_SUFFIX}
	cp -fR $(srcdir)/HYPRE_*.h $(HYPRE_BUILD_DIR)/include
	cp -fR $(srcdir)/seq_mv.h $(HYPRE_BUILD_DIR)/include
#	cp -fR libHYPRE* $(HYPRE_BUILD_DIR)/lib

install: libHYPRE_seq_mv${HYPRE_LIB_SUFFIX}
	cp -fR $(srcdir)/HYPRE_*.h $(HYPRE_INC_INSTALL)
	cp -fR $(srcdir)/seq_mv.h $(HYPRE_INC_INSTALL)
#	cp -fR libHYPRE* $(HYPRE_LIB_INSTALL)

clean:
	rm -f *.o libHYPRE*
	rm -rf pchdir tca.map *inslog*

distclean: clean

##################################################################
# Rules
##################################################################

libHYPRE_seq_mv.a: ${OBJS} ${CUOBJS}
	@echo  "Building $@ ... "
	${AR} $@ ${OBJS}
	${RANLIB} $@

libHYPRE_seq_mv.so libHYPRE_seq_mv.dylib: ${OBJS} ${CUOBJS}
	@echo  "Building $@ ... "
	${BUILD_CC_SHARED} -o ${SONAME} ${OBJS} ${SHARED_SET_SONAME}${SONAME}
	ln -s ${SONAME} $@

${OBJS}: ${HEADERS}

=== src/sstruct_mv/Makefile ===
#BHEADER**********************************************************************
# Copyright (c) 2008,  Lawrence Livermore National Security, LLC.
# Produced at the Lawrence Livermore National Laboratory.
# This file is part of HYPRE.  See file COPYRIGHT for details.
#
# HYPRE is free software; you can redistribute it and/or modify it under the
# terms of the GNU Lesser General Public License (as published by the Free
# Software Foundation) version 2.1 dated February 1999.
#
# $Revision$
#EHEADER**********************************************************************


include ../config/Makefile.config

CINCLUDES = ${INCLUDES} ${MPIINCLUDE}

C_COMPILE_FLAGS = \
 -I..\
 -I$(srcdir)\
 -I$(srcdir)/..\
 -I$(srcdir)/../utilities\
 -I$(srcdir)/../struct_mv\
 -I$(srcdir)/../seq_mv\
 -I$(srcdir)/../parcsr_mv\
 -I$(srcdir)/../IJ_mv\
 ${CINCLUDES}

HEADERS =\
 HYPRE_sstruct_mv.h\
 _hypre_sstruct_mv.h\
 sstruct_graph.h\
 sstruct_grid.h\
 sstruct_matrix.h\
 sstruct_stencil.h\
 sstruct_vector.h

FILES =\
 F90_HYPRE_sstruct_graph.c\
 F90_HYPRE_sstruct_grid.c\
 F90_HYPRE_sstruct_matrix.c\
 F90_HYPRE_sstruct_stencil.c\
 F90_HYPRE_sstruct_vector.c\
 HYPRE_sstruct_graph.c\
 HYPRE_sstruct_grid.c\
 HYPRE_sstruct_matrix.c\
 HYPRE_sstruct_stencil.c\
 HYPRE_sstruct_vector.c\
 sstruct_axpy.c\
 sstruct_copy.c\
 sstruct_graph.c\
 sstruct_grid.c\
 sstruct_innerprod.c\
 sstruct_matrix.c\
 sstruct_matvec.c\
 sstruct_scale.c\
 sstruct_stencil.c\
 sstruct_vector.c

OBJS = ${FILES:.c=.o}

SONAME = libHYPRE_sstruct_mv-${HYPRE_RELEASE_VERSION}${HYPRE_LIB_SUFFIX}

##################################################################
# Targets
##################################################################

all: libHYPRE_sstruct_mv${HYPRE_LIB_SUFFIX}
	cp -fR $(srcdir)/HYPRE_*.h $(HYPRE_BUILD_DIR)/include
	cp -fR $(srcdir)/_hypre_sstruct_mv.h $(HYPRE_BUILD_DIR)/include
#	cp -fR libHYPRE* $(HYPRE_BUILD_DIR)/lib

install: libHYPRE_sstruct_mv${HYPRE_LIB_SUFFIX}
	cp -fR $(srcdir)/HYPRE_*.h $(HYPRE_INC_INSTALL)
	cp -fR $(srcdir)/_hypre_sstruct_mv.h $(HYPRE_INC_INSTALL)
#	cp -fR libHYPRE* $(HYPRE_LIB_INSTALL)

clean:
	rm -f *.o libHYPRE*
	rm -rf pchdir tca.map *inslog*

distclean: clean

##################################################################
# Rules
##################################################################

libHYPRE_sstruct_mv.a: ${OBJS}
	@echo  "Building $@ ... "
	${AR} $@ ${OBJS}
	${RANLIB} $@

libHYPRE_sstruct_mv.so libHYPRE_sstruct_mv.dylib: ${OBJS}
	@echo  "Building $@ ... "
	${BUILD_CC_SHARED} -o ${SONAME} ${OBJS} ${SHARED_SET_SONAME}${SONAME}
	ln -s ${SONAME} $@

${OBJS}: ${HEADERS}

=== src/struct_ls/Makefile ===
#BHEADER**********************************************************************
# Copyright (c) 2008,  Lawrence Livermore National Security, LLC.
# Produced at the Lawrence Livermore National Laboratory.
# This file is part of HYPRE.  See file COPYRIGHT for details.
#
# HYPRE is free software; you can redistribute it and/or modify it under the
# terms of the GNU Lesser General Public License (as published by the Free
# Software Foundation) version 2.1 dated February 1999.
#
# $Revision$
#EHEADER**********************************************************************


include ../config/Makefile.config

CINCLUDES = ${INCLUDES} ${MPIINCLUDE}

C_COMPILE_FLAGS = \
 -I..\
 -I$(srcdir)\
 -I$(srcdir)/..\
 -I$(srcdir)/../multivector\
 -I$(srcdir)/../utilities\
 -I$(srcdir)/../krylov\
 -I$(srcdir)/../struct_mv\
 ${CINCLUDES}

HEADERS =\
 HYPRE_struct_ls.h\
 _hypre_struct_ls.h\
 pfmg.h\
 red_black_gs.h\
 smg.h\
 sparse_msg.h

FILES =\
 coarsen.c\
 cyclic_reduction.c\
 F90_HYPRE_struct_bicgstab.c\
 F90_HYPRE_struct_cycred.c\
 F90_HYPRE_struct_flexgmres.c\
 F90_HYPRE_struct_gmres.c\
 F90_HYPRE_struct_lgmres.c\
 F90_HYPRE_struct_hybrid.c\
 F90_HYPRE_struct_int.c\
 F90_HYPRE_struct_jacobi.c\
 F90_HYPRE_struct_pcg.c\
 F90_HYPRE_struct_pfmg.c\
 F90_HYPRE_struct_smg.c\
 F90_HYPRE_struct_sparse_msg.c\
 general.c\
 hybrid.c\
 HYPRE_struct_bicgstab.c\
 HYPRE_struct_cycred.c\
 HYPRE_struct_flexgmres.c\
 HYPRE_struct_gmres.c\
 HYPRE_struct_hybrid.c\
 HYPRE_struct_int.c\
 HYPRE_struct_jacobi.c\
 HYPRE_struct_lgmres.c\
 HYPRE_struct_pcg.c\
 HYPRE_struct_pfmg.c\
 HYPRE_struct_smg.c\
 HYPRE_struct_sparse_msg.c\
 jacobi.c\
 pcg_struct.c\
 pfmg2_setup_rap.c\
 pfmg3_setup_rap.c\
 pfmg.c\
 pfmg_relax.c\
 pfmg_setup.c\
 pfmg_setup_interp.c\
 pfmg_setup_rap5.c\
 pfmg_setup_rap7.c\
 pfmg_setup_rap.c\
 pfmg_solve.c\
 point_relax.c\
 red_black_constantcoef_gs.c\
 red_black_gs.c\
 semi.c\
 semi_interp.c\
 semi_restrict.c\
 semi_setup_rap.c\
 smg2_setup_rap.c\
 smg3_setup_rap.c\
 smg_axpy.c\
 smg.c\
 smg_relax.c\
 smg_residual.c\
 smg_setup.c\
 smg_setup_interp.c\
 smg_setup_rap.c\
 smg_setup_restrict.c\
 smg_solve.c\
 sparse_msg2_setup_rap.c\
 sparse_msg3_setup_rap.c\
 sparse_msg.c\
 sparse_msg_filter.c\
 sparse_msg_interp.c\
 sparse_msg_restrict.c\
 sparse_msg_setup.c\
 sparse_msg_setup_rap.c\
 sparse_msg_solve.c

OBJS = ${FILES:.c=.o}

SONAME = libHYPRE_struct_ls-${HYPRE_RELEASE_VERSION}${HYPRE_LIB_SUFFIX}

##################################################################
# Targets
##################################################################

all: libHYPRE_struct_ls${HYPRE_LIB_SUFFIX}
	cp -fR $(srcdir)/HYPRE_*.h $(HYPRE_BUILD_DIR)/include
	cp -fR $(srcdir)/_hypre_struct_ls.h $(HYPRE_BUILD_DIR)/include
#	cp -fR libHYPRE* $(HYPRE_BUILD_DIR)/lib

install: libHYPRE_struct_ls${HYPRE_LIB_SUFFIX}
	cp -fR $(srcdir)/HYPRE_*.h $(HYPRE_INC_INSTALL)
	cp -fR $(srcdir)/_hypre_struct_ls.h $(HYPRE_INC_INSTALL)
#	cp -fR libHYPRE* $(HYPRE_LIB_INSTALL)

clean:
	rm -f *.o libHYPRE*
	rm -rf pchdir tca.map *inslog*

distclean: clean

##################################################################
# Rules
##################################################################

libHYPRE_struct_ls.a: ${OBJS}
	@echo  "Building $@ ... "
	${AR} $@ ${OBJS}
	${RANLIB} $@

libHYPRE_struct_ls.so libHYPRE_struct_ls.dylib: ${OBJS}
	@echo  "Building $@ ... "
	${BUILD_CC_SHARED} -o ${SONAME} ${OBJS} ${SHARED_SET_SONAME}${SONAME}
	ln -s ${SONAME} $@

${OBJS}: ${HEADERS}

=== debian/changelog ===
hypre (2.16.0-4) unstable; urgency=medium

  * Team upload.
  * fix handling of nocheck build option

 -- Drew Parsons <dparsons@debian.org>  Sat, 27 Jul 2019 00:15:05 +0800

hypre (2.16.0-3) unstable; urgency=medium

  * Team upload.
  * don't run build-time tests if the nocheck option has been
    specified in DEB_BUILD_OPTIONS
  * status

 -- Drew Parsons <dparsons@debian.org>  Fri, 26 Jul 2019 17:17:44 +0800

hypre (2.16.0-2) unstable; urgency=medium

  * Team upload.
  * Standards-Version: 4.4.0

 -- Drew Parsons <dparsons@debian.org>  Sun, 14 Jul 2019 14:42:09 +0800

hypre (2.16.0-1exp1) experimental; urgency=medium

  * Team upload.
  * New upstream release.
    - remove patches applied upstream:
      fix_race_condition_b99fe77.patch
      fix_race_condition_97cd175.patch
  * Update debian/watch to new upstream repo,
    https://github.com/hypre-space/hypre
  * Standards-Version: 4.3.0
  * debhelper compatibility level 12
  * debian patch bootstrap-path.patch adds path to ./update-release.sh
    in src/config/bootstrap

 -- Drew Parsons <dparsons@debian.org>  Sat, 13 Apr 2019 22:49:51 +0800

=== debian/control ===
Source: hypre
Section: math
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: "Adam C. Powell, IV" <hazelsct@debian.org>
Standards-Version: 4.4.0
Build-Depends:
 autoconf,
 automake,
 debhelper-compat (= 12),
 pkg-config,
 gfortran,
 libblas-dev | libopenblas-dev | libatlas-base-dev | libblas.so,
 liblapack-dev | libopenblas-dev | libatlas-base-dev | liblapack.so,
 libsuperlu-dev, libsuperlu-dist-dev,
 libltdl-dev,
 libtool,
 mpi-default-dev,
Vcs-Git: https://salsa.debian.org/science-team/hypre.git
Vcs-Browser: https://salsa.debian.org/science-team/hypre
Homepage: http://www.llnl.gov/casc/hypre/

Package: libhypre-dev
Multi-Arch: same
Architecture: any
Section: libdevel
Depends:
 libhypre-2.16.0 (= ${binary:Version}),
 libopenblas-dev | libatlas-base-dev | libblas-dev | libblas.so,
 libopenblas-dev | libatlas-base-dev | liblapack-dev | liblapack.so,
 libsuperlu-dev,
 mpi-default-dev,
 ${misc:Depends},
Description: High Performance Matrix Preconditioners - Development Files
 Hypre is a set of matrix preconditioning libraries to aid in the solution of
 large systems of linear equations.
 .
 This package contains the headers and symlinks necessary to develop programs
 which use hypre.
 .
 To reduce the size of the library, HYPRE is split into sublibraries:
 libHYPRE.so is a dummy library linked to:
 - libHYPRE_core.so
 - libHYPRE_FEI.so

Package: libhypre-2.16.0
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: High Performance Matrix Preconditioners - Shared Library
 Hypre is a set of matrix preconditioning libraries to aid in the solution of
 large systems of linear equations.
 .
 This package contains the shared libraries.

=== debian/rules ===
#!/usr/bin/make -f
# Made with the aid of debmake, by Christoph Lameter,
# based on the sample debian/rules file for GNU hello by Ian Jackson.

DEB_VERSION := $(shell dpkg-parsechangelog -S Version)
DEB_NOEPOCH_VERSION := $(shell echo $(DEB_VERSION) | cut -d: -f2-)
DEB_UPSTREAM_VERSION := $(shell echo $(DEB_NOEPOCH_VERSION) | sed 's/-[^-]*$$//')

export HYPRE_SOVERSION=$(DEB_UPSTREAM_VERSION)

export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic -O3
export DEB_CXXFLAGS_MAINT_APPEND  = -Wall -pedantic -O3
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--no-as-needed
export DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
export DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)

%:
	dh $@ --sourcedirectory=src --with autoreconf

# to avoid lintian warnings
CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
CFLAGS:=$(shell dpkg-buildflags --get CFLAGS)
CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS)
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)

# extra flags set to be similar to what petsc requires
extra_flags += \
  --with-fei --with-mli \
  --with-superlu --with-superlu-include=/usr/include/superlu --with-superlu-lib="-lsuperlu" \
  --with-dsuperlu --with-dsuperlu-include=/usr/include/superlu-dist --with-dsuperlu-lib="-lsuperlu_dist" \
  --with-blas --with-blas-lib="-lblas" \
  --with-lapack-libs="lapack" --with-lapack-lib-dirs="/usr/lib/lapack" --with-fmangle-lapack="one-underscore" \
  --with-MPI-include=$(shell pkg-config --cflags-only-I mpi | awk '{print $$1}' | sed "s/^-I//") \
  --with-MPI-libs="$(shell pkg-config --libs-only-l mpi | sed 's/-l//g')" \
  --with-MPI-lib-dirs="$(shell pkg-config --libs-only-L mpi | sed 's/-L//g')" \
  --with-MPI-flags="$(shell pkg-config --libs-only-other mpi)" \
  --with-extra-flags="($shell pkg-config --cflags-only-other mpi)" \
  --prefix=$(CURDIR)/debian/tmp/usr

# To get petsc support when indexTypes.integerSize == 64
#ifeq ($(DEB_HOST_ARCH),amd64)
#   extra_flags +=  --enable-bigint
#endif

# from pets:
# # explicitly tell hypre BLAS/LAPACK mangling since it may not match Fortran mangling
#    if self.blasLapack.mangling == 'underscore':
#      mang = 'one-underscore'
#    elif self.blasLapack.mangling == 'caps':
#      mang = 'caps-no-underscores'
#    else:
#      mang = 'no-underscores'
#    args.append('--with-fmangle-blas='+mang)
#    args.append('--with-fmangle-lapack='+mang)


# Other options from src/configure
  # --enable-debug          Set compiler flags for debugging.
  # --enable-shared         Build shared libraries (default is NO).
  # --enable-bigint         Use long long int for HYPRE_Int (default is NO).
  # --enable-complex        Use complex values (default is NO).
  # --enable-maxdim=MAXDIM  Change max dimension size to MAXDIM (default is 3).
  #                         Currently must be at least 3.
  # --enable-persistent     Uses persistent communication (default is NO).
  # --enable-hopscotch      Uses hopscotch hashing if configured with OpenMP and
  #                         atomic capability available(default is NO).
  # --enable-global-partition
  #                         Use global partitioning (default is NO).
  # --enable-fortran        Require a working Fortran compiler (default is YES).

export OMPI_MCA_orte_rsh_agent=/bin/false

override_dh_auto_clean:
	echo "Running clean"
	rm -rf $(CURDIR)/debian/tmp
	rm -f src/configure.in
	rm -f src/config.log
	rm -f src/config/config.guess
	rm -f src/config/config.sub
	cd src/test; \
	for TEST in TEST_*; do \
	  rm -f $${TEST}.stdout $${TEST}.stderr; \
	done
	-dh_auto_clean

override_dh_autoreconf:
	cp /usr/share/misc/config.* src/config/
	cd src && ./config/bootstrap

override_dh_auto_configure:
	dh_auto_configure -- $(extra_flags) --enable-shared
	#dh_auto_configure -p libhypre-complex -- $(extra_flags) --enable-shared --enable-complex


# disable build tests for these arches:
# ia64 consistently times out on tests
# armel occasionally times out
ARCH_NO_TEST_LIST = armel ia64

empty :=
space := $(empty)$(empty)

# run tests, or not
RUNTEST=yes
ifneq (,$(findstring $(space)$(DEB_HOST_ARCH)$(space), $(space)$(ARCH_NO_TEST_LIST)$(space)))
  RUNTEST=no
endif
# don't run tests if the nocheck build option has been specified
ifeq (nocheck,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
  RUNTEST=no
endif

override_dh_auto_test:
	set -e; \
	if [ "$(RUNTEST)" = "no" ]; then \
	  echo Tests have been disabled on $(DEB_HOST_ARCH); \
	else echo "Building tests"; \
	  $(MAKE) -C src test VERBOSE=1; \
	  echo "Running tests"; \
	  set -e; \
	  export LD_LIBRARY_PATH=$(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH):$(LD_LIBRARY_PATH); \
	  cd src/test; \
	  test_return="ok"; \
	  for TEST in TEST_*; do \
	    echo -n "running $${TEST} ... "; \
	    if ./runtest.sh -t $${TEST}/*.sh >$${TEST}.stdout 2>$${TEST}.stderr ; then \
	      echo ok; \
	    else \
	      test_return=$$?; \
	      echo "error found with error code $${test_return}"; \
	      echo "===== error logs for $${TEST} ====="; \
	      echo "$${TEST} stdout:"; \
	      cat $${TEST}.stdout; \
	      echo "$${TEST} stderr:"; \
	      cat $${TEST}.stderr; \
	      echo "===== end error logs for $${TEST} with error code $${test_return} ====="; \
	    fi; \
	  done; \
	  if [ $${test_return} != "ok" ]; then \
	      echo "Tests failed with last error code $${test_return}"; \
	      return $${test_return}; \
	  fi; \
	fi

# upstream places the soname in front of .so
# which makes it trickier than desirable to exclude
# the versioned so files in a libhypre-dev.install file
# Easier to just override instead
override_dh_install:
	dh_install -p libhypre-$(HYPRE_SOVERSION) usr/lib/*/*${HYPRE_SOVERSION}.so
	dh_install -p libhypre-dev --exclude=${HYPRE_SOVERSION} usr/lib/*/*
	dh_install -p libhypre-dev usr/include/hypre


# run examples (add -W, -no-as-needed on Unbuntu for ex5f)
#	echo "Building examples"
#	$(MAKE) -C src/examples \
#          HYPRE_LIB_INSTALL=$(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH) \
#          HYPRE_INC_INSTALL=$(CURDIR)/debian/tmp/usr/include/hypre
#	ALLPROGS="ex1 ex2 ex3 ex4 ex5 ex5f \
#          ex6 ex7 ex8 ex9 ex11 ex12 ex12f" ; \
#	for ex in $$ALLPROGS; do \
#	   echo "Running $$ex"; \
#	   ls -l src/examples/$$ex; \
#	   mpirun -np 2 src/examples/$$ex ; \
#	done
#	ALLPROGS="ex13 ex14" ; \
#	for ex in $$ALLPROGS; do \
#	   echo "Running $$ex"; \
#	   mpirun -np 3 src/examples//$$ex ; \
#	done
#	ALLPROGS="ex15" ; \
#	for ex in $$ALLPROGS; do \
#	   echo "Running $$ex"; \
#	   mpirun -np 8 src/examples//$$ex ; \
#	done
#	ALLPROGS="ex16" ; \
#	for ex in $$ALLPROGS; do \
#	   echo "Running $$ex"; \
#	   mpirun -np 4 src/examples//$$ex ; \
#	done
#

# run testsuite

#	cd src/test; \
#	for file in `find . -name \*.sh | egrep "^./TEST" | egrep -v "fei|babel|timing"`; do \
#	   echo "./runtest.sh $$file" \
#	   ./runtest.sh $$file; \
#	done; \
#	cd ../..
